<?php


abstract class BasesfGallery extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $user_id;


	
	protected $name;


	
	protected $dir;


	
	protected $description;


	
	protected $photo_id;


	
	protected $created_at;


	
	protected $updated_at;

	
	protected $asfGuardUserProfile;

	
	protected $asfPhoto;

	
	protected $collsfPhotos;

	
	protected $lastsfPhotoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getUserId()
	{

		return $this->user_id;
	}

	
	public function getName()
	{

		return $this->name;
	}

	
	public function getDir()
	{

		return $this->dir;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getPhotoId()
	{

		return $this->photo_id;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
						$ts = strtotime($this->updated_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = sfGalleryPeer::ID;
		}

	} 
	
	public function setUserId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = sfGalleryPeer::USER_ID;
		}

		if ($this->asfGuardUserProfile !== null && $this->asfGuardUserProfile->getUserId() !== $v) {
			$this->asfGuardUserProfile = null;
		}

	} 
	
	public function setName($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = sfGalleryPeer::NAME;
		}

	} 
	
	public function setDir($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->dir !== $v) {
			$this->dir = $v;
			$this->modifiedColumns[] = sfGalleryPeer::DIR;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = sfGalleryPeer::DESCRIPTION;
		}

	} 
	
	public function setPhotoId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->photo_id !== $v) {
			$this->photo_id = $v;
			$this->modifiedColumns[] = sfGalleryPeer::PHOTO_ID;
		}

		if ($this->asfPhoto !== null && $this->asfPhoto->getId() !== $v) {
			$this->asfPhoto = null;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = sfGalleryPeer::CREATED_AT;
		}

	} 
	
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = sfGalleryPeer::UPDATED_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->user_id = $rs->getInt($startcol + 1);

			$this->name = $rs->getString($startcol + 2);

			$this->dir = $rs->getString($startcol + 3);

			$this->description = $rs->getString($startcol + 4);

			$this->photo_id = $rs->getInt($startcol + 5);

			$this->created_at = $rs->getTimestamp($startcol + 6, null);

			$this->updated_at = $rs->getTimestamp($startcol + 7, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating sfGallery object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasesfGallery:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(sfGalleryPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			sfGalleryPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasesfGallery:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasesfGallery:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(sfGalleryPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(sfGalleryPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(sfGalleryPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasesfGallery:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->asfGuardUserProfile !== null) {
				if ($this->asfGuardUserProfile->isModified()) {
					$affectedRows += $this->asfGuardUserProfile->save($con);
				}
				$this->setsfGuardUserProfile($this->asfGuardUserProfile);
			}

			if ($this->asfPhoto !== null) {
				if ($this->asfPhoto->isModified()) {
					$affectedRows += $this->asfPhoto->save($con);
				}
				$this->setsfPhoto($this->asfPhoto);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = sfGalleryPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += sfGalleryPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collsfPhotos !== null) {
				foreach($this->collsfPhotos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->asfGuardUserProfile !== null) {
				if (!$this->asfGuardUserProfile->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->asfGuardUserProfile->getValidationFailures());
				}
			}

			if ($this->asfPhoto !== null) {
				if (!$this->asfPhoto->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->asfPhoto->getValidationFailures());
				}
			}


			if (($retval = sfGalleryPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collsfPhotos !== null) {
					foreach($this->collsfPhotos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = sfGalleryPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUserId();
				break;
			case 2:
				return $this->getName();
				break;
			case 3:
				return $this->getDir();
				break;
			case 4:
				return $this->getDescription();
				break;
			case 5:
				return $this->getPhotoId();
				break;
			case 6:
				return $this->getCreatedAt();
				break;
			case 7:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = sfGalleryPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUserId(),
			$keys[2] => $this->getName(),
			$keys[3] => $this->getDir(),
			$keys[4] => $this->getDescription(),
			$keys[5] => $this->getPhotoId(),
			$keys[6] => $this->getCreatedAt(),
			$keys[7] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = sfGalleryPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUserId($value);
				break;
			case 2:
				$this->setName($value);
				break;
			case 3:
				$this->setDir($value);
				break;
			case 4:
				$this->setDescription($value);
				break;
			case 5:
				$this->setPhotoId($value);
				break;
			case 6:
				$this->setCreatedAt($value);
				break;
			case 7:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = sfGalleryPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUserId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDir($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDescription($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setPhotoId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setCreatedAt($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setUpdatedAt($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(sfGalleryPeer::DATABASE_NAME);

		if ($this->isColumnModified(sfGalleryPeer::ID)) $criteria->add(sfGalleryPeer::ID, $this->id);
		if ($this->isColumnModified(sfGalleryPeer::USER_ID)) $criteria->add(sfGalleryPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(sfGalleryPeer::NAME)) $criteria->add(sfGalleryPeer::NAME, $this->name);
		if ($this->isColumnModified(sfGalleryPeer::DIR)) $criteria->add(sfGalleryPeer::DIR, $this->dir);
		if ($this->isColumnModified(sfGalleryPeer::DESCRIPTION)) $criteria->add(sfGalleryPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(sfGalleryPeer::PHOTO_ID)) $criteria->add(sfGalleryPeer::PHOTO_ID, $this->photo_id);
		if ($this->isColumnModified(sfGalleryPeer::CREATED_AT)) $criteria->add(sfGalleryPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(sfGalleryPeer::UPDATED_AT)) $criteria->add(sfGalleryPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(sfGalleryPeer::DATABASE_NAME);

		$criteria->add(sfGalleryPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUserId($this->user_id);

		$copyObj->setName($this->name);

		$copyObj->setDir($this->dir);

		$copyObj->setDescription($this->description);

		$copyObj->setPhotoId($this->photo_id);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getsfPhotos() as $relObj) {
				$copyObj->addsfPhoto($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new sfGalleryPeer();
		}
		return self::$peer;
	}

	
	public function setsfGuardUserProfile($v)
	{


		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}


		$this->asfGuardUserProfile = $v;
	}


	
	public function getsfGuardUserProfile($con = null)
	{
		if ($this->asfGuardUserProfile === null && ($this->user_id !== null)) {
						include_once 'plugins/sfGuardPluginPlus/lib/model/om/BasesfGuardUserProfilePeer.php';

			$this->asfGuardUserProfile = sfGuardUserProfilePeer::retrieveByPK($this->user_id, $con);

			
		}
		return $this->asfGuardUserProfile;
	}

	
	public function setsfPhoto($v)
	{


		if ($v === null) {
			$this->setPhotoId(NULL);
		} else {
			$this->setPhotoId($v->getId());
		}


		$this->asfPhoto = $v;
	}


	
	public function getsfPhoto($con = null)
	{
		if ($this->asfPhoto === null && ($this->photo_id !== null)) {
						include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfPhotoPeer.php';

			$this->asfPhoto = sfPhotoPeer::retrieveByPK($this->photo_id, $con);

			
		}
		return $this->asfPhoto;
	}

	
	public function initsfPhotos()
	{
		if ($this->collsfPhotos === null) {
			$this->collsfPhotos = array();
		}
	}

	
	public function getsfPhotos($criteria = null, $con = null)
	{
				include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfPhotoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collsfPhotos === null) {
			if ($this->isNew()) {
			   $this->collsfPhotos = array();
			} else {

				$criteria->add(sfPhotoPeer::GALLERY_ID, $this->getId());

				sfPhotoPeer::addSelectColumns($criteria);
				$this->collsfPhotos = sfPhotoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(sfPhotoPeer::GALLERY_ID, $this->getId());

				sfPhotoPeer::addSelectColumns($criteria);
				if (!isset($this->lastsfPhotoCriteria) || !$this->lastsfPhotoCriteria->equals($criteria)) {
					$this->collsfPhotos = sfPhotoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastsfPhotoCriteria = $criteria;
		return $this->collsfPhotos;
	}

	
	public function countsfPhotos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfPhotoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(sfPhotoPeer::GALLERY_ID, $this->getId());

		return sfPhotoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addsfPhoto(sfPhoto $l)
	{
		$this->collsfPhotos[] = $l;
		$l->setsfGallery($this);
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasesfGallery:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasesfGallery::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 