<?php


abstract class BasesfPhoto extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $gallery_id;


	
	protected $name;


	
	protected $description;


	
	protected $filename;


	
	protected $moderation_status = 1;


	
	protected $created_at;


	
	protected $updated_at;

	
	protected $asfGallery;

	
	protected $collsfGallerys;

	
	protected $lastsfGalleryCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getGalleryId()
	{

		return $this->gallery_id;
	}

	
	public function getName()
	{

		return $this->name;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getFilename()
	{

		return $this->filename;
	}

	
	public function getModerationStatus()
	{

		return $this->moderation_status;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
						$ts = strtotime($this->updated_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = sfPhotoPeer::ID;
		}

	} 
	
	public function setGalleryId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->gallery_id !== $v) {
			$this->gallery_id = $v;
			$this->modifiedColumns[] = sfPhotoPeer::GALLERY_ID;
		}

		if ($this->asfGallery !== null && $this->asfGallery->getId() !== $v) {
			$this->asfGallery = null;
		}

	} 
	
	public function setName($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = sfPhotoPeer::NAME;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = sfPhotoPeer::DESCRIPTION;
		}

	} 
	
	public function setFilename($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->filename !== $v) {
			$this->filename = $v;
			$this->modifiedColumns[] = sfPhotoPeer::FILENAME;
		}

	} 
	
	public function setModerationStatus($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->moderation_status !== $v || $v === 1) {
			$this->moderation_status = $v;
			$this->modifiedColumns[] = sfPhotoPeer::MODERATION_STATUS;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = sfPhotoPeer::CREATED_AT;
		}

	} 
	
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = sfPhotoPeer::UPDATED_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->gallery_id = $rs->getInt($startcol + 1);

			$this->name = $rs->getString($startcol + 2);

			$this->description = $rs->getString($startcol + 3);

			$this->filename = $rs->getString($startcol + 4);

			$this->moderation_status = $rs->getInt($startcol + 5);

			$this->created_at = $rs->getTimestamp($startcol + 6, null);

			$this->updated_at = $rs->getTimestamp($startcol + 7, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating sfPhoto object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasesfPhoto:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(sfPhotoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			sfPhotoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasesfPhoto:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasesfPhoto:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(sfPhotoPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(sfPhotoPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(sfPhotoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasesfPhoto:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->asfGallery !== null) {
				if ($this->asfGallery->isModified()) {
					$affectedRows += $this->asfGallery->save($con);
				}
				$this->setsfGallery($this->asfGallery);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = sfPhotoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += sfPhotoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collsfGallerys !== null) {
				foreach($this->collsfGallerys as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->asfGallery !== null) {
				if (!$this->asfGallery->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->asfGallery->getValidationFailures());
				}
			}


			if (($retval = sfPhotoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collsfGallerys !== null) {
					foreach($this->collsfGallerys as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = sfPhotoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getGalleryId();
				break;
			case 2:
				return $this->getName();
				break;
			case 3:
				return $this->getDescription();
				break;
			case 4:
				return $this->getFilename();
				break;
			case 5:
				return $this->getModerationStatus();
				break;
			case 6:
				return $this->getCreatedAt();
				break;
			case 7:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = sfPhotoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getGalleryId(),
			$keys[2] => $this->getName(),
			$keys[3] => $this->getDescription(),
			$keys[4] => $this->getFilename(),
			$keys[5] => $this->getModerationStatus(),
			$keys[6] => $this->getCreatedAt(),
			$keys[7] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = sfPhotoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setGalleryId($value);
				break;
			case 2:
				$this->setName($value);
				break;
			case 3:
				$this->setDescription($value);
				break;
			case 4:
				$this->setFilename($value);
				break;
			case 5:
				$this->setModerationStatus($value);
				break;
			case 6:
				$this->setCreatedAt($value);
				break;
			case 7:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = sfPhotoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setGalleryId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDescription($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setFilename($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setModerationStatus($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setCreatedAt($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setUpdatedAt($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(sfPhotoPeer::DATABASE_NAME);

		if ($this->isColumnModified(sfPhotoPeer::ID)) $criteria->add(sfPhotoPeer::ID, $this->id);
		if ($this->isColumnModified(sfPhotoPeer::GALLERY_ID)) $criteria->add(sfPhotoPeer::GALLERY_ID, $this->gallery_id);
		if ($this->isColumnModified(sfPhotoPeer::NAME)) $criteria->add(sfPhotoPeer::NAME, $this->name);
		if ($this->isColumnModified(sfPhotoPeer::DESCRIPTION)) $criteria->add(sfPhotoPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(sfPhotoPeer::FILENAME)) $criteria->add(sfPhotoPeer::FILENAME, $this->filename);
		if ($this->isColumnModified(sfPhotoPeer::MODERATION_STATUS)) $criteria->add(sfPhotoPeer::MODERATION_STATUS, $this->moderation_status);
		if ($this->isColumnModified(sfPhotoPeer::CREATED_AT)) $criteria->add(sfPhotoPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(sfPhotoPeer::UPDATED_AT)) $criteria->add(sfPhotoPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(sfPhotoPeer::DATABASE_NAME);

		$criteria->add(sfPhotoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setGalleryId($this->gallery_id);

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setFilename($this->filename);

		$copyObj->setModerationStatus($this->moderation_status);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getsfGallerys() as $relObj) {
				$copyObj->addsfGallery($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new sfPhotoPeer();
		}
		return self::$peer;
	}

	
	public function setsfGallery($v)
	{


		if ($v === null) {
			$this->setGalleryId(NULL);
		} else {
			$this->setGalleryId($v->getId());
		}


		$this->asfGallery = $v;
	}


	
	public function getsfGallery($con = null)
	{
		if ($this->asfGallery === null && ($this->gallery_id !== null)) {
						include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfGalleryPeer.php';

			$this->asfGallery = sfGalleryPeer::retrieveByPK($this->gallery_id, $con);

			
		}
		return $this->asfGallery;
	}

	
	public function initsfGallerys()
	{
		if ($this->collsfGallerys === null) {
			$this->collsfGallerys = array();
		}
	}

	
	public function getsfGallerys($criteria = null, $con = null)
	{
				include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfGalleryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collsfGallerys === null) {
			if ($this->isNew()) {
			   $this->collsfGallerys = array();
			} else {

				$criteria->add(sfGalleryPeer::PHOTO_ID, $this->getId());

				sfGalleryPeer::addSelectColumns($criteria);
				$this->collsfGallerys = sfGalleryPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(sfGalleryPeer::PHOTO_ID, $this->getId());

				sfGalleryPeer::addSelectColumns($criteria);
				if (!isset($this->lastsfGalleryCriteria) || !$this->lastsfGalleryCriteria->equals($criteria)) {
					$this->collsfGallerys = sfGalleryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastsfGalleryCriteria = $criteria;
		return $this->collsfGallerys;
	}

	
	public function countsfGallerys($criteria = null, $distinct = false, $con = null)
	{
				include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfGalleryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(sfGalleryPeer::PHOTO_ID, $this->getId());

		return sfGalleryPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addsfGallery(sfGallery $l)
	{
		$this->collsfGallerys[] = $l;
		$l->setsfPhoto($this);
	}


	
	public function getsfGallerysJoinsfGuardUserProfile($criteria = null, $con = null)
	{
				include_once 'plugins/sfGalleryPlugin/lib/model/om/BasesfGalleryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collsfGallerys === null) {
			if ($this->isNew()) {
				$this->collsfGallerys = array();
			} else {

				$criteria->add(sfGalleryPeer::PHOTO_ID, $this->getId());

				$this->collsfGallerys = sfGalleryPeer::doSelectJoinsfGuardUserProfile($criteria, $con);
			}
		} else {
									
			$criteria->add(sfGalleryPeer::PHOTO_ID, $this->getId());

			if (!isset($this->lastsfGalleryCriteria) || !$this->lastsfGalleryCriteria->equals($criteria)) {
				$this->collsfGallerys = sfGalleryPeer::doSelectJoinsfGuardUserProfile($criteria, $con);
			}
		}
		$this->lastsfGalleryCriteria = $criteria;

		return $this->collsfGallerys;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasesfPhoto:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasesfPhoto::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 