<?php

/**
 * Subclass for performing query and update operations on the 'sf_photo' table.
 *
 * 
 *
 * @package lib.model
 */ 
class sfPhotoPeer extends BasesfPhotoPeer
{

  static public function getPhotos($user_id = 0, $page = 1) {
    $c = new Criteria();
    $c->addDescendingOrderByColumn(sfPhotoPeer::CREATED_AT);
    if ($user_id) {
      $c->addJoin(sfPhotoPeer::GALLERY_ID, sfGalleryPeer::ID);
      $c->add(sfGalleryPeer::USER_ID, $user_id);
    }
    $g = sfPhotoPeer::doSelectWidthPager($c, $page);

    return $g;
  }

  static public function getPhotosByUserId($user_id) {
    $c = new Criteria();
    $c->addDescendingOrderByColumn(sfPhotoPeer::CREATED_AT);
    $c->setLimit(10);
    $c->addJoin(sfPhotoPeer::GALLERY_ID, sfGalleryPeer::ID);
    $c->add(sfGalleryPeer::USER_ID, $user_id);
    $g = sfPhotoPeer::doSelect($c);
    return $g;
  }

  public static function doSelectWidthPager(Criteria $criteria, $npage, $con = null)
  {
    $pager = new sfPropelPager('sfPhoto', 50);
    $pager->setCriteria($criteria);
    $pager->setPage($npage);
    $pager->setPeerMethod('doSelect');
    $pager->init();
    return $pager;
  } 

}
