<?php

/**
 * sfGallery actions.
 *
 * @package    project
 * @subpackage sfGallery
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 2692 2006-11-15 21:03:55Z fabien $
 */
class sfGalleryActions extends sfActions
{

  public function executeAllGalleries() {
    $this->elements = sfGalleryPeer::getListByUserId(0, $this->getRequestParameter('page', 1));
  }

  public function executeBrowsePhotos() {
    $this->elements = sfPhotoPeer::getPhotos(0, $this->getRequestParameter('page', 1));
  }

  public function executeGalleries() {
    if ($profile = $this->getContext()->getUser()->getProfile())
      $this->elements = $profile->getsfGallerys();
    else
      $this->redirect('@homepage');
  }

  public function executeShow() {
		sfPropelModerationBehavior::disable();
    $this->g = sfGalleryPeer::retrieveByPK($this->getRequestParameter('id'));
    $this->elements = $this->g->getsfPhotos();
  }

  public function executePhoto() {
    $this->p = sfPhotoPeer::retrieveByPK($this->getRequestParameter('id'));
    $this->g = sfGalleryPeer::retrieveByPK($this->p->getGalleryId());
		$this->p->incrementCounter();
  }

  public function executeAddGallery() {
  }

  public function handleErrorCreateGallery() {
    $this->forward('sfGallery', 'addGallery');
  }

  public function executeCreateGallery() {
    $u = new sfGallery();
    $u->setDir(strtolower(sfInflector::camelize(strip_tags($this->getRequestParameter('name')))));
    $u->setName(strip_tags($this->getRequestParameter('name')));
    $u->setDescription(strip_tags($this->getRequestParameter('description')));
    $u->setUserId($this->getContext()->getUser()->getProfile()->getUserId(), $this->getRequestParameter('id'));
		$u->addTag($this->getRequestParameter('tags'));
    $u->save();
    $this->redirect('@sf_mygalleries');
  }

  public function executeAddPhoto() {
  }

  public function handleErrorCreatePhoto() {
    return sfView::ERROR;
  }

  public function executeCreatePhoto() {
    $sFileExtension = $this->getRequest()->getFileExtension('photo');
    $sMimeType = $this->getRequest()->getFileType('photo');
    $sInternalFileName = strtolower(sfInflector::camelize(strip_tags($this->getRequestParameter('name')))).$sFileExtension;

    $u = new sfPhoto();
    $u->setName(strip_tags($this->getRequestParameter('name')));
    $u->setGalleryId($this->getRequestParameter('gallery_id'));
    $u->setFilename($sInternalFileName);
    $u->setDescription(strip_tags($this->getRequestParameter('description')));
		$u->addTag($this->getRequestParameter('tags'));
		$u->tagAsUnsafe();
    $u->save();

    $g = sfGalleryPeer::retrieveByPK($this->getRequestParameter('gallery_id'));

    $path = sfConfig::get('sf_upload_dir') . '/gallery/'.$g->getDir().'/';
    $thumb_path = sfConfig::get('sf_upload_dir') . '/gallery/'.$g->getDir().'/thumbs/';
    if (!is_dir($path)) mkdir($path, 0777);
    if (!is_dir($thumb_path)) mkdir($thumb_path, 0777);
    $this->getRequest()->moveFile('photo', $path . $sInternalFileName);

    $oThumbnail = new sfThumbnail(500, 500);
    $oThumbnail->loadFile($path . $sInternalFileName, $sMimeType);
    $oThumbnail->save($path . $sInternalFileName);

    $oThumbnail = new sfThumbnail(65, 65);
    $oThumbnail->loadFile($path . $sInternalFileName, $sMimeType);
    $oThumbnail->save($thumb_path . $sInternalFileName);

    $this->redirect('@sf_mygalleries');
  }

  public function executeDeletePhoto() {
    $p = sfPhotoPeer::retrieveByPK($this->getRequestParameter('id'));
    $g = sfGalleryPeer::retrieveByPK($p->getGalleryId());

    if ($g->getPhotoId() == $p->getId()) {
      $error = 'Photo which is setup as a thumbnail for gallery can not be deleted. Please change thumbnail and then delete this photo';
      throw new Exception($error);
    }

    $path = sfConfig::get('sf_upload_dir') . '/gallery/'.$g->getDir().'/'.$p->getFilename();
    $thumb_path = sfConfig::get('sf_upload_dir') . '/gallery/'.$g->getDir().'/thumbs/'.$p->getFilename();

    $p->delete();
    
    unlink($path);
    unlink($thumb_path);

    $this->redirect('@sf_mygalleries');
  }

  public function executeSetThumbnail() {
    $p = sfPhotoPeer::retrieveByPK($this->getRequestParameter('id'));
    $g = sfGalleryPeer::retrieveByPK($p->getGalleryId());
    $g->setPhotoId($p->getId());
    $g->save();

    $this->redirect('@sf_mygalleries');
  }

  public function executePhotosByUserId() {
    $c = new Criteria();
    $c->add(sfGuardUserProfilePeer::NICKNAME, $this->getRequestParameter('id'));
    $g = sfGuardUserProfilePeer::doSelectOne($c);
    $this->elements = sfPhotoPeer::getPhotos($g->getUserId(), $this->getRequestParameter('page', 1));
  }

  public function executeSetProfileImage() {
    $p = sfPhotoPeer::retrieveByPK($this->getRequestParameter('id'));
    $g = $p->getsfGallery();

    $thumb_path = sfConfig::get('sf_upload_dir') . '/gallery/'.$g->getDir().'/thumbs/'.$p->getFilename();
    $full_path = sfConfig::get('sf_upload_dir') . '/gallery/'.$g->getDir().'/thumbs/'.$p->getFilename();
    $profile_path = sfConfig::get('sf_upload_dir') . '/assets/' . $this->getUser()->getProfile()->getId();
    if (!is_dir($profile_path)) mkdir($profile_path, 0777);
    copy($thumb_path, $profile_path . '/thumb_profile.jpg');
    copy($full_path, $profile_path . '/full_profile.jpg');

    $this->redirect('@sf_guard_changeprofile');
  }

}